import 'package:get/get.dart';
import 'package:progbonus_vendor_client/progbonus_vendor_client.dart';

abstract class IProgBonusService {
  ProgBonusBonus? get bonus;

  Future<ProgBonusBonus?> getBonuses();
}

class ProgBonusService extends GetxService implements IProgBonusService {
  ProgBonusService({IProgBonusClient? client}) : _client = client ?? Get.find();

  final IProgBonusClient _client;

  final _bonus = Rxn<ProgBonusBonus>();
  @override
  ProgBonusBonus? get bonus => _bonus.value;

  @override
  Future<ProgBonusBonus?> getBonuses() async {
    final bonusInfo = await _client.getBonuses();
    if (bonusInfo.isFail) {
      _bonus.value = null;
      return null;
    }
    _bonus.value = bonusInfo.value;
    return bonus;
  }
}
